<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scan_provider".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ScanProvider".
 *
 * Columns in table "scan_provider" available as properties of the model,
 * followed by relations of table "scan_provider" available as properties of the model.
 *
 * @property integer $id
 * @property integer $scan_practice_id
 * @property integer $provider_id
 * @property integer $primary_location
 * @property string $rating
 * @property integer $listing_accuracy
 * @property integer $missing_listings
 * @property integer $profile_completion_score
 * @property integer $completed_scans
 * @property integer $cnt_errors
 * @property integer $data_elements
 * @property integer $reviews
 * @property integer $healthgrades_reviews
 * @property string $healthgrades_primary_specialty
 * @property string $reviews_grade
 * @property string $provider_name
 * @property string $missing_listing_names
 * @property string $profile_completion_missing_data
 * @property string $date_added
 *
 * @property Provider $provider
 * @property ScanPractice $scanPractice
 */
abstract class BaseScanProvider extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scan_provider';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ScanProvider|ScanProviders', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('scan_practice_id, provider_id, primary_location', 'required'),
            array('scan_practice_id, provider_id, primary_location, listing_accuracy, missing_listings, '
                . 'profile_completion_score, completed_scans, cnt_errors, data_elements, reviews, '
                . 'healthgrades_reviews', 'numerical', 'integerOnly' => true),
            array('rating, reviews_grade', 'length', 'max' => 3),
            array('healthgrades_primary_specialty, provider_name', 'length', 'max' => 255),
            array('missing_listing_names, profile_completion_missing_data, date_added', 'safe'),
            array('rating, listing_accuracy, missing_listings, profile_completion_score, cnt_errors, reviews, '
                . 'healthgrades_reviews, healthgrades_primary_specialty, reviews_grade, provider_name, '
                . 'missing_listing_names, profile_completion_missing_data, date_added', 'default',
                'setOnEmpty' => true, 'value' => null),
            array('id, scan_practice_id, provider_id, primary_location, rating, listing_accuracy, missing_listings, '
                . 'profile_completion_score, completed_scans, cnt_errors, data_elements, reviews, '
                . 'healthgrades_reviews, healthgrades_primary_specialty, reviews_grade, provider_name, '
                . 'missing_listing_names, profile_completion_missing_data, date_added', 'safe', 'on' => 'search'),
            array('id, scan_practice_id, provider_id, rating, listing_accuracy, missing_listings, '
                . 'profile_completion_score, cnt_errors, reviews, healthgrades_reviews, '
                . 'healthgrades_primary_specialty, reviews_grade, provider_name, missing_listing_names, '
                . 'profile_completion_missing_data, date_added', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'scanPractice' => array(self::BELONGS_TO, 'ScanPractice', 'scan_practice_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'scan_practice_id' => null,
            'provider_id' => null,
            'primary_location' => 'Primary Location',
            'rating' => Yii::t('app', 'Rating'),
            'listing_accuracy' => Yii::t('app', 'Listing Accuracy'),
            'missing_listings' => Yii::t('app', 'Missing Listings'),
            'profile_completion_score' => Yii::t('app', 'Profile Completion Score'),
            'completed_scans' => 'Completed Scans',
            'cnt_errors' => Yii::t('app', 'Cnt Errors'),
            'data_elements' => 'Data Elements',
            'reviews' => Yii::t('app', 'Reviews'),
            'healthgrades_reviews' => Yii::t('app', 'Healthgrades Reviews'),
            'healthgrades_primary_specialty' => Yii::t('app', 'Healthgrades Primary Specialty'),
            'reviews_grade' => Yii::t('app', 'Reviews Grade'),
            'provider_name' => Yii::t('app', 'Provider Name'),
            'missing_listing_names' => Yii::t('app', 'Missing Listing Names'),
            'profile_completion_missing_data' => Yii::t('app', 'Profile Completion Missing Data'),
            'date_added' => Yii::t('app', 'Date Added'),
            'provider' => null,
            'scanPractice' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('scan_practice_id', $this->scan_practice_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('primary_location', $this->primary_location);
        $criteria->compare('rating', $this->rating, true);
        $criteria->compare('listing_accuracy', $this->listing_accuracy);
        $criteria->compare('missing_listings', $this->missing_listings);
        $criteria->compare('profile_completion_score', $this->profile_completion_score);
        $criteria->compare('completed_scans', $this->completed_scans);
        $criteria->compare('cnt_errors', $this->cnt_errors);
        $criteria->compare('data_elements', $this->data_elements);
        $criteria->compare('reviews', $this->reviews);
        $criteria->compare('healthgrades_reviews', $this->healthgrades_reviews);
        $criteria->compare('healthgrades_primary_specialty', $this->healthgrades_primary_specialty, true);
        $criteria->compare('reviews_grade', $this->reviews_grade, true);
        $criteria->compare('provider_name', $this->provider_name, true);
        $criteria->compare('missing_listing_names', $this->missing_listing_names, true);
        $criteria->compare('profile_completion_missing_data', $this->profile_completion_missing_data, true);
        $criteria->compare('date_added', $this->date_added, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
